//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Magenta
#property indicator_color2  Lime
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_width1  3
#property indicator_width2  3

//
//
//
//
//

extern string TimeFrame       = "current time frame";
extern int    Price           = 0; 
extern int    Risk            = 1;
extern double levelOb         = 90;
extern double levelOs         = 10;

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = true;
extern string soundFile       = "alert2.wav";

//
//
//
//
//

double arrDn[];
double arrUp[];
double wpr[];
double trend[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,arrDn); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,arrUp); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,wpr);
   SetIndexBuffer(3,trend);
   
     //
     //
     //
     //
     //
     
         indicatorFileName = WindowExpertName();
         calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) { return(0); }
         returnBars        = TimeFrame=="returnBars";     if (returnBars)     { return(0); }
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" Trend Signal");
   return(0);
}

int deinit() { return(0); }

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { arrDn[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   double x1 = levelOb + Risk;
   double x2 = levelOs - Risk;
   if (calculateValue || timeFrame == Period())
   {
     for (int i=limit; i>=0 ; i--)
     {
        int    period = 3+Risk*2;
        double range  = 0; for (int k=0; k<10; k++) range += High[i+k]-Low[i+k]; range /= 10.0;
        bool   found1 = false; for (k=0; k<6 && !found1; k++) found1 = (MathAbs(Open[i+k] -Close[i+k+1])>=range*2.0);
        bool   found2 = false; for (k=0; k<9 && !found2; k++) found2 = (MathAbs(Close[i+k+3]-Close[i+k])>=range*4.6);
               if (found1) period = 3;
               if (found2) period = 4;
               double price = iMA(NULL,0,1,0,MODE_SMA,Price,i); 
               double hi    = High[iHighest(NULL,0,MODE_HIGH,period,i)];
               double lo    =  Low[ iLowest(NULL,0,MODE_LOW, period,i)];
               if (hi!=lo)      
                    wpr[i]  = 100+(-100)*(hi - price) / (hi - lo);
               else wpr[i]  = 0;  

        //
        //
        //
        //
        //
               
        arrDn[i] = EMPTY_VALUE;
        arrUp[i] = EMPTY_VALUE;
        trend[i] = trend[i+1];
           if (wpr[i] < x2) { for (k=1; i+k<Bars && wpr[i+k]>=x2 && wpr[i+k]<=x1;) k++; if (wpr[i+k]>x1) trend[i] =-1; }
           if (wpr[i] > x1) { for (k=1; i+k<Bars && wpr[i+k]>=x2 && wpr[i+k]<=x1;) k++; if (wpr[i+k]<x2) trend[i] = 1; }
           if (trend[i]== 1) arrUp[i] = 1;
           if (trend[i]==-1) arrDn[i] = 1;
     }
   
   manageAlerts();
   return(0);
   }           
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         arrDn[i] = EMPTY_VALUE;
         arrUp[i] = EMPTY_VALUE;
         trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,Risk,3,y);
         
         if (trend[i] == 1) arrUp[i] = 1;  
         if (trend[i] ==-1) arrDn[i] = 1; 
    }
    manageAlerts();
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert(whichBar,"up");
         else  doAlert(whichBar,"down");       
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," trend signal direction changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," trend signal "),message);
             if (alertsSound)   PlaySound(soundFile );
      }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
} 
   
//
//
//
//
//


